<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class Admin_CommentController extends Controller
{
    /**
    * set access privileges
    */  
    function init()
    {        
        $this->acl->allow('administrator', $this->name, "*");
         
        if(!$this->acl->isAllowed($this->session->get("role"), $this->name, $this->action))
        {
            $this->redirect(FrontController::getRewrittedUrl("/admin/main/logIn"));  
        }
    }   
    
    /**
    * Display comment all or for specified site
    */
    function indexAction($siteId = 0)
    {                  
        /**
        * create site list for select  
        */
        $c = new Criteria();    
        $this->set("sites", $this->site->generateList($c, "siteTitle"));
        
        $c = new Criteria();
        
        if($siteId)
        {
            //because we must retrieve site status
            $c->addInnerJoin("sites", "sites.siteId", "comments.siteId");
            
            switch($siteId)
            {
                //add criteria rule
                case "-1": $c->add("status", "validated"); break;
                case "-2": $c->add("status", "waiting"); break;
                default: $c->add("comments.siteId", $siteId);
            }
        }

        $this->set("siteId", $siteId);
        $this->set("comments", $this->comment->findAll($c));
    }
    
    /**
    * Update this comment     
    */
    function saveAction()
    {
        $data = $this->request->getArray(array("text", "pseudo", "date"));
        $this->comment->updateByPk($data, $this->request->commentId);
        
        $this->set("status", "OK");
        $this->viewClass = "JsonView";    
    }
    
    /**
    * Delete this comment
    */
    function deleteAction()
    {
        $this->comment->delByPk($this->request->commentId);
        
        $this->set("status", "OK");
        $this->viewClass = "JsonView";
    }
    
    /**
    * Ban comment ip
    */
    function banIpAction()
    {
        $bannedIp = new BannedIpRecord();
        $bannedIp->remoteIp= $this->request->remoteIp;
        $bannedIp->save();
            
        $this->set("status", "OK");
        $this->viewClass = "JsonView";   
    }
} 

?>