<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class Admin_SitemapController extends Controller
{
    function init()
    {        
        $this->acl->allow('administrator', $this->name, "*");
         
        if(!$this->acl->isAllowed($this->session->get("role"), $this->name, $this->action))
        {
            $this->redirect(FrontController::getRewrittedUrl("/admin/main/logIn"));  
        }
    }   
    
    function indexAction()
    {
        $doc = new XmlGenerator();

        $root = new XmlElement('urlset');
        $doc->appendChild($root);
        
        $root->setAttribute('xmlns', 'http://www.sitemaps.org/schemas/sitemap/0.9');
        
        // add static links
		$urlRewriting = Config::get('urlRewriting');
        $siteRootUrl = Config::get('siteRootUrl');
        
		$root->addLink($siteRootUrl, '', 'always', '1.0');

		$root->addLink($siteRootUrl . 'nouveautes.html', '', 'always', '1.0');
		$root->addLink($siteRootUrl . 'rss-nouveautes.xml', '', 'always', '0.8');
		$root->addLink($siteRootUrl . 'top-notes.html', '', '', '0.8');
		$root->addLink($siteRootUrl . 'top-hits.html', '', '', '0.8');
		$root->addLink($siteRootUrl . 'top-referrers.html', '', '', '0.8');
		$root->addLink($siteRootUrl . 'top-rank.html', '', '', '0.8');
		$root->addLink($siteRootUrl . 'allcategories.html', '', 'weekly', '1.0');
		$root->addLink($siteRootUrl . 'contact.html', '', '', '1.0');

        
        // add all sites links
        $sites = $this->Site->findAll();
        
        foreach($sites as $site)
        {
            if($site['status'] != 'validated')continue; 

            $_id = $site['siteId'];      
            $_name_for_url = FrontController::changeFr($site['name']);
            $_created = FrontController::changeFr($site['creationDate']);

            $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/details/' . $_id . '/' . $_name_for_url, false), "$_created", '', '1.0');
       
        }
		
        // add all categories links
        $categories = $this->Category->findAll();
        foreach($categories as $category)
        {
            $_id = $category['categoryId'];
            $_name_for_url = FrontController::changeFr($category['name']);

            $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/category/'.$_id.'/'.$_name_for_url.'/1', false), "", '', '1.0');
        }
		
        // save file
        $output = fopen(CODE_ROOT_DIR.'sitemap.xml', "wb");
        $text_xml = utf8_encode($doc->saveXML());
        $success = (fwrite($output, $text_xml) > 0);
    
    }
}