
BackgroundTask = function(taskId)
{
    this.form = $("backgroundTaskControlForm");
    this.taskId = taskId; 
    this.ajax = new AjaxClient();
    var buttons = new Array("start", "stop", "pause", "resume");
              
    for(i in buttons)
    {
       var buttonName = buttons[i];
       
       if(this.form[buttonName])
       {
           $(this.form[buttonName]).addEvent("click", this[buttonName + "OnClick"].handler(this));
       }
    }
    
    this.onStartSuccess();
}

BackgroundTask.prototype = 
{
    taskId: null,
    form: null,
    ajax: null,
    buttonsUpdated: false,
    executed: false,
    
    sendControlAction: function(action)
    {
        var ajax = new AjaxClient();
        ajax.addParam("taskId", this.taskId);
        ajax.post('/admin/task/' + action);
    },
    
    startOnClick: function()
    {
       this.executed = true;
       $(this.form.start).hide();
       $(this.form.pause).show();
       $(this.form.stop).show();
       
       var ajax = new AjaxClient();
       ajax.onSuccess = this.onStartSuccess.handler(this);
       ajax.addParam("taskId", this.taskId);
       ajax.sendForm(this.form, setting.siteRootUrl + '/admin/task/init', "post");
    },
    
    stopOnClick: function()
    {
        $(this.form.start).show();
        $(this.form.pause).hide();
        $(this.form.resume).hide();
        this.sendControlAction("stop");
    },
    
    pauseOnClick: function()
    {
        $(this.form.pause).hide();
        $(this.form.resume).show();
        this.sendControlAction("pause");
    },
    
    resumeOnClick: function()
    {
        $(this.form.resume).hide();
        $(this.form.pause).show();
        this.sendControlAction("resume");
    },
    
    onStartSuccess: function(ajaxObj)
    {
        $('progressBar').style.width = "0%";    
        this.updateStatus();
    },
    
    updateStatus: function()
    {
        var ajax = new AjaxClient();
        ajax.onSuccess = this.onUpdateStatusSuccess.handler(this);
        ajax.addParam("taskId", this.taskId);
        ajax.post('/admin/task/getStatus');     
    },
    
    updateButtonsState: function(status)
    {
        this.buttonsUpdated = true;
        
        if(status == "active")
        {
            $(this.form.start).hide();
            $(this.form.pause).show();
            $(this.form.stop).show();
        }
        
        if(status == "pause")
        {
            $(this.form.start).hide();
            $(this.form.pause).hide();
            $(this.form.resume).show();
            $(this.form.stop).show();            
        } 
    },
    
    onUpdateStatusSuccess: function(ajaxObj)
    {
        var task = ajaxObj.parseJSON();
        //alert(task.status);
        
        if(task.status == "active" || task.status == "finish" || task.status == "pause")
        {
            if(!this.buttonsUpdated)
            {
                this.updateButtonsState(task.status);
            }

            $('progressBarOutline').show();

            $('taskParsedItems').innerHTML = task.parsedItems;
            $('taskStatus').innerHTML = task.status;   

            if(task.totalItems > 0)
                var percentage = (Math.floor(task.parsedItems * 100 / task.totalItems)).toString() + "%";
            else
                var percentage = "100%";
                                                         
            $('progressBar').style.width = percentage;
            $('taskPercentage').innerHTML = percentage;
            $('progressInformation').show(); 
        }
         
        if(!task.status || task.status == "finish")
        {
            $(this.form.resume).hide();
            $(this.form.pause).hide();
            $(this.form.stop).hide();
            $(this.form.start).show();
            $('progressBarOutline').hide();
            
            if(this.executed)
            {
                window.location.reload(false); 
            } 
        }
        else
        {
            window.setTimeout(this.updateStatus.handler(this), 1000); 
        }
  
    }
}
