<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class CommentController extends Controller
{
    private $cookieName;
    
    /**
    * Check that user can vote 
    */
    function checkCanVote()
    {
        //if user is banned
        if($this->bannedIp->isBanned($this->request->getIp()))
            return 'You are not allowed to post comments.';
            
        //if have commenting today
        if(isset($_COOKIE[$this->cookieName]) && $_COOKIE[$this->cookieName] == date('d.m.Y'))
            return 'You have already commented this site today.';

        return false;
    }
    
    function popupAction($siteId)
    {           
        //if comments aren't enabled return 404
        if(!Config::get("commentsEnabled"))return $this->return404();  
           
        $c = new Criteria();
        $c->add("siteId", $siteId);
    
        $this->set("siteId", $siteId);
        
        $this->cookieName = md5('siteComment' . $siteId);
        $displayForm = true;
        
        //check can vote
        $errorMessage = $this->checkCanVote();
         
         //if no
        if($errorMessage)
        {
            $displayForm = false;
        }
        else
        {
            //if post comment
            
            if(isset($this->request->text))
            {
                //check Captcha if enabled
                if(Config::get('captchaEnabledOnComments')
                   && !$this->captchaCode->validatePublicAndPrivateCodes($this->request))
                   $errorMessage = 'You did not guess the error correcting code, please try again.';
                
                //if captcha is okey save comment
                if(!$errorMessage)
                {
                    setcookie(
                                $this->cookieName, 
                                date('d.m.Y'), 
                                mktime ( 0, 0, 0, date('n'), date('j'), date('Y')) + 60 * 60 * 24);
                                  
                    // insert comment
                    $comment = new CommentRecord();
                    $comment->remoteIp = $this->request->getIp();
                    $comment->siteId = $siteId;
                    $comment->text = $this->request->text; 
                    $comment->pseudo  = $this->request->pseudo;
                    $comment->save();
                    $displayForm = false;
                }
                else
                {
                    //captcha is wrong
                    $displayForm = true;
                }
            }
        }
        
        //set error message
        if(!empty($errorMessage))
        {
            $this->set("errorMessage", $errorMessage);
        }
                      
        //get all comment for this site
        $this->set("comments", $this->comment->findAll($c));  
        $this->set("displayForm", $displayForm);   
    }
}

?>