<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class MenuController extends Controller
{
    /**
    * Display left menu categories
    */
    function displayCategoriesAction()
    {                 
        //get category to display set in /site/category
        $parentId = Display::get("currentCategoryId", 0);
        
        //check is this menu was cached before
        $cache = Cacher::getInstance(); 
        if(($categories = $cache->load("categoryMenu".$parentId)) === null)
        {       
            $categories = $this->category->getChilds($parentId);
            $cache->save($categories);
        }
        
        $this->set("categories", $categories);
        $this->viewFile = "menuleft/categories";
    }
    
    /**
    * Display left menu keywords index
    */
    function displayKeywordsAction()
    {
        $cache = Cacher::getInstance();
        
        //set cache name separated for languages and templates name because save HTML
        $cacheItemName = "letterIndexHtml".Config::get("language")."Template".Config::get("templateName");
        
        if(($keywordHtml = $cache->load($cacheItemName, false)) === null)
        { 
            $lettersCount = array();
            
            //get keywords count which start for letter
            foreach($this->keyword->getLetterIndex() as $row)
            {
                $lettersCount[$row['letter']] = $row['keywordsCount'];
            }

            //create letters list to display
            $ranges = array(range('A', 'Z'), range('0','9'));
            $keywordParts = array();
            
            foreach($ranges as $range)
            {
                $keywords = array(); 
                
                foreach($range as $letter)
                {
                    $keywords[] = array("letter" => $letter,
                                        "counter" => isset($lettersCount[$letter]) ? $lettersCount[$letter] : 0  );
                }
                   
                //divide keywords for columns                        
                $keywordParts = array_merge($keywordParts, array_chunk($keywords, 10));
            }
            
            $this->set("keywordParts", $keywordParts);
            $this->viewFile = "menuleft/keywords";
            $keywordHtml = $this->render();
            
            $cache->save($keywordHtml, $cacheItemName, false);
        }
        
        return $keywordHtml;
    }
    
    /**
    * Display left menu statistics
    */
    function displayStatisticsAction()
    {
        $cache = Cacher::getInstance();
        
        //set cache name separated for languages and templates name because save HTML 
        $cacheItemName = "statisticHtml".Config::get("language")."Template".Config::get("templateName");
        
        if(($statsHtml = $cache->load($cacheItemName, false)) === null)
        { 
            //get stats defined in statistic model
            $this->set("statistic", $this->statistic->getAllStats());
            $this->viewFile = "menuleft/statistics";

            $statsHtml = $this->render();

            $cache->save($statsHtml, $cacheItemName, false);
        }
        
        return $statsHtml;
    }
    
    /**
    * Display execution statistic
    */
    function displayExecutionStatsAction()
    {
        return $this->statistic->getExecutionStats();
    }
}
?>