<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

/**
 * Class which retrieve and store values to/from cache
 */
class Cacher extends DataAggregator
{
    private static $instance = null;
    private $lastId;
    private $lastSerialized;
    private $cacheDir;
    
    /**
     * Returns an instance of Cacher object
     * @return Cacher 
     */
    public static function getInstance()
    {
        if(self::$instance === null)
        {
            self::$instance = new self();
        }

        return self::$instance;
    }

    /**
     * Generates the standard Cacher object
     */      
    public function __construct()
    {
        $this->cacheDir = CODE_ROOT_DIR."cache/";
        clearstatcache();    
    }
    
    /**
    * Generating filename of cache basing on id 
    */
    private static function idToFileName($id)
    {
        return ''.$id.'';
    }
    
    private function getCachePath($id)
    {
        return $this->cacheDir.$this->idToFileName($id);
    }
    
    public function save($buff, $id = null, $serialized = null)
    {
        if($id == null)$id = $this->lastId; 
        if($serialized === null)$serialized = $this->lastSerialized; 
        $cache_path = $this->getCachePath($id); 
        if($serialized)$buff = serialize($buff);
        file_put_contents($cache_path, $buff);
    }
    
    public function delete($id)
    {
        $cache_path = $this->getCachePath($id);
            
        foreach(glob($cache_path) as $file)
        {
            if($file == ".htaccess")continue;
            unlink($file);  
        }
        
    }
    
    public function load($id, $serialized = true)
    {
        $this->lastId = $id;
        $this->lastSerialized = $serialized; 
        
        $cache_path = $this->getCachePath($id); 
        
        if(file_exists($cache_path) && ($buff = @file_get_contents($cache_path)))
        {
            if($serialized)$buff = unserialize($buff);   
            return $buff;
        }
    }
}

?>