
WebsiteEditor = function()
{
    this.form = $("websiteEditForm");  
        
    this.counter = new TextLengthCounter();

    this.counter.appendToField(this.form.description,
                               setting.siteDescriptionMaxLength,
                               'siteDescrCharsLeftField');

    var keys = new KeywordSelector();
    keys.form = this.form;
    keys.duplicateMsg = "You have already added this keyword. Select another one.";
    keys.maxCount = setting.maxKeywordsCountPerSite;  
    keys.init();

    this.keywordSelector = keys;

    this.form.addEvent("submit", this.onSubmit.handler(this));

    if(setting.siteId)
    {
        ajax.addParam("siteId", setting.siteId)
        .set("onSuccess", this.onSuccessEditData.handler(this))                                  
        .post(setting.websiteDataUrl);
    }
    else
    {
        this.form.show();
    }

    if(setting.metaDataUrl)
    {
        $("metaTagButton").addEvent("click", this.onMetaTagButtonClick.handler(this));
    }

};

WebsiteEditor.prototype =
{ 
    form: null,
    counter: null,
    keywordSelector: null,
    validator: null,

    onMetaDataSuccess: function(ajaxObj)
    { 
        var metaData = ajaxObj.parseJSON(); 
  
        this.form.description.value = metaData.description;
        this.form.siteTitle.value = metaData.title;
        this.counter.updateStringLength();
        //$("metaDataLoader").hide();
        //$("metaTagButton").show(); 
    },
    
    onMetaDataLoading: function()
    {
        this.form.siteTitle.value = "Loading..."; 
        //$("metaDataLoader").show();
    },
    
    onMetaTagButtonClick: function()
    {    
        ajax.set("onSuccess", this.onMetaDataSuccess.handler(this));
        ajax.set("onLoading", this.onMetaDataLoading.handler(this));
        ajax.addParam("url", this.form.url.value);
        ajax.post(setting.metaDataUrl);
    },
    
    onSuccessEditData: function(ajaxObj)
    {
        var site = ajaxObj.parseJSON();
        ajax.fillForm(this.form, site);
        this.counter.updateStringLength();
        this.keywordSelector.loadKeywords(site.keywordIds);
        this.form.show();
    },
    
    onSubmit: function(event)
    {
        if(!this.validator || this.validator.validate())
        {
            if(!setting.websiteFormNormalPost)
            {
                ajax.set("onSuccess", this.onSubmitSuccess.handler(this));
                ajax.set("onLoading", this.onLoading.handler(this));
                ajax.sendForm(event.obj);
                event.preventDefault();
            }
        }
        else
        {
            event.preventDefault();
        }
        
    },
    
    onLoading: function(ajaxObj)
    {
        $('siteLoader').show();
    },
    
    onSubmitSuccess: function(ajaxObj)
    {
        $('siteLoader').hide();
        var response = ajaxObj.parseJSON(); 

        switch(response.status)
        {
            case "ok":
                alert(response.message);
                if(response.refresh)
                {
                    window.location.reload(false);
                } 
                break;
            
            case "sendFile":
                this.form.submit();
                break;
            
            case "error":
                alert(response.message);
                break;
        } 
    }
      
}
  