<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class CommentModel extends Model
{   
    protected $primaryKey = "commentId";
    
    function insert($data)
    {
        parent::insert($data);
        $siteId = $data['siteId'];
        $this->updateSiteCommentsCount($siteId);
    }
    
    function del($c, $updateStats = true)
    {
        parent::del($c);
        $condition = $c->getCondition("siteId");
        
        if($updateStats)
        {
            $this->updateSiteCommentsCount($condition['value']);
        }   
    }
    
    function updateSiteCommentsCount($siteId)
    {
        $c = new Criteria();
        $c->add("siteId", $siteId);
        $commentsCount = $this->getCount($c);
        $this->site->update(array("commentsCount" => $commentsCount), $c);
    }
}

class CommentRecord extends ModelRecord
{
    
}

?>