<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class OtherReferrerSiteModel extends Model
{   
    protected $primaryKey = "referrerSiteId";
    
    function removeAll()
    {
        $c = new Criteria();
        $this->del($c);
        $this->site->update(array("referrerTimes" => 0), $c);
        
        $todayDate = date("Y-m-d");
        $this->setting->set('topReferrersLastResetDate', $todayDate);
        Cacher::getInstance()->delete("*"); 
    }
    
    function incReferrerTimesOfSiteIfSiteIsInscripted($referrerUrl)
    {
        if ($referrerUrl == '' || strlen($referrerUrl) <= strlen('http://'))
        return;
        
        $hostName = $this->site->getHostNameFromUrl($referrerUrl);
        $c = new Criteria();
        $c->add("url", $hostName);
        $this->site->update(array("_referrerTimes" => "referrerTimes + 1"), $c);
    }
    
    function saveRefferingFromNotRegisteredSite($referrerUrl)
    {
        $hostName = $this->site->getHostNameFromUrl($referrerUrl);
        
        $c = new Criteria();
        $c->add("url", $hostName);
        
        if($this->getCount($c))
        {
            $this->update(array("_ReferrerTimes" => "ReferrerTimes + 1"), $c);       
        }
        else
        {
            $record = new OtherReferrerSiteRecord();
            $record->url = $hostName;
            $record->referrerTimes = 1;
            $record->save();       
        }

    }
    
    function checkReset()
    {
        $removalNeeded = false;

        $todayDate = date("Y-m-d"); 
        $lastResetDate = Config::get('topReferrersLastResetDate');

        if(!preg_match('#^[0-9]{4}-[0-9]{2}-[0-9]{2}$#', $lastResetDate, $match))
        {
            // invalid date
            $removalNeeded = true;
        }
        else
        {
            $todayTime = strtotime($todayDate);
            $nextRefreshTime = strtotime($lastResetDate." + " . Config::get('deletionPeriodOfTopReferrers') . " days");

            if($nextRefreshTime <= $todayTime)
                $removalNeeded = true;
        }
        
        if($removalNeeded)
        {
            $this->removeAll();
        }    
    }
    
    function saveReferrer($referrerUrl)
    {         
        $this->checkReset();
        
        $this->incReferrerTimesOfSiteIfSiteIsInscripted($referrerUrl);
        $this->saveRefferingFromNotRegisteredSite($referrerUrl); // save for registered sites too 
    }
}  


class OtherReferrerSiteRecord extends ModelRecord
{
    
}

?>